/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.scene.MapThread
 *  fire.pb.scene.Scene
 *  fire.pb.scene.movable.Role
 *  fire.pb.util.Parser
 *  gnet.link.Onlines
 *  mkio.Protocol
 */
package fire.pb.scene.manager;

import fire.pb.scene.MapThread;
import fire.pb.scene.Scene;
import fire.pb.scene.movable.Role;
import fire.pb.util.Parser;
import gnet.link.Onlines;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import mkio.Protocol;

public class RoleManager {
    private static RoleManager instance;
    private final Map<Long, Role> roles = new HashMap<Long, Role>();
    public final Map<Integer, Set<Long>> campRoles = new HashMap<Integer, Set<Long>>();
    private final Map<Integer, Set<Long>> schoolRoles = new HashMap<Integer, Set<Long>>();

    public Role getRoleByID(long roleID) {
        return this.roles.get(roleID);
    }

    public Role getRoleByProtocol(Protocol protocol) {
        long roleid = Onlines.getInstance().findRoleid(protocol);
        return -1L == roleid ? null : this.roles.get(roleid);
    }

    public void insert(long roleID, Role role) {
        this.roles.put(roleID, role);
    }

    public void remove(long roleID) {
        this.roles.remove(roleID);
    }

    public int getSize() {
        return this.roles.size();
    }

    public Map<Long, Role> getRoles() {
        return this.roles;
    }

    public void addRoleToSchool(long roleid, int schoolid) {
        Set<Long> roleids = this.schoolRoles.get(schoolid);
        if (roleids == null) {
            roleids = new HashSet<Long>();
            this.schoolRoles.put(schoolid, roleids);
        }
        roleids.add(roleid);
    }

    public void removeRoleFromSchool(long roleid) {
        Role role = RoleManager.getInstance().getRoleByID(roleid);
        if (null == role) {
            return;
        }
        int schoolid = role.getSchoolId();
        Set<Long> roleids = this.schoolRoles.get(schoolid);
        if (roleids != null) {
            roleids.remove(roleid);
        }
    }

    public void addRoleToCamp(long roleid, int camp) {
        Set<Long> roleids = this.campRoles.get(camp);
        if (roleids == null) {
            roleids = new HashSet<Long>();
            this.campRoles.put(camp, roleids);
        }
        roleids.add(roleid);
    }

    public void removeRoleFromCamp(long roleid) {
        Role role = RoleManager.getInstance().getRoleByID(roleid);
        if (null == role) {
            return;
        }
        int camp = role.getCamp();
        Set<Long> roleids = this.campRoles.get(camp);
        if (roleids != null) {
            roleids.remove(roleid);
        }
    }

    public Set<Long> getSchoolRoles(int schoolid) {
        return this.schoolRoles.get(schoolid);
    }

    public static RoleManager getInstance() {
        if (null == instance) {
            instance = new RoleManager();
        }
        if (!Thread.currentThread().getName().equals(MapThread.MAP_THREAD_NAME) && !Thread.currentThread().getName().equals("main")) {
            Scene.LOG.info((Object)("有非MapThread线程调用RoleManager，ThreadName = " + Thread.currentThread().getName()));
            Scene.LOG.info((Object)Parser.convertStackTrace2String((StackTraceElement[])Thread.currentThread().getStackTrace()));
        }
        return instance;
    }

    private RoleManager() {
    }
}

